
#include"book_accounting.h"
#include <Windows.h>

void init_gen(cl_BookAccounter& p_bacc)
{
	str_BookAccount A1(2, "family_nameA", str_Date(1999, 12, 12), str_Date(2021, 1, 1), "Auth2", "BookA", 2001, "PH1", 1500);
	str_BookAccount A2(5, "family_nameB", str_Date(2009, 11, 4), str_Date(2021, 1, 1), "Auth2", "BookE", 2002, "PH1", 1500);
	str_BookAccount A3(6, "family_nameC", str_Date(2020, 7, 24), str_Date(2018, 1, 1), "Auth5", "BookG", 1995, "PH3", 1500);
	str_BookAccount A4(8, "family_nameA", str_Date(2019, 2, 19), str_Date(2020, 1, 21), "Auth1", "BookJ", 1965, "PH2", 1500);
	str_BookAccount A5(1, "family_name1F", str_Date(2000, 1, 10), str_Date(2021, 1, 1), "Auth1", "BookH", 1899, "PH0", 1500);
	str_BookAccount A6(3, "family_name1G", str_Date(2018, 11, 1), str_Date(2021, 1, 1), "Auth6", "BookB", 2012, "PH1", 1500);
	str_BookAccount A7(4, "family_name1H", str_Date(2020, 9, 14), str_Date(2021, 1, 1), "Auth2", "BookA", 2019, "PH1", 1500);
	str_BookAccount A8(5, "family_name1B", str_Date(2018, 10, 16), str_Date(2020, 3, 17), "Auth3", "BookF", 1987, "PH3", 1500);
	str_BookAccount A9(8, "family_name1A", str_Date(2019, 10, 28), str_Date(2019, 1, 1), "Auth4", "BookI", 1920, "PH2", 1500);
	str_BookAccount A10(9, "family_nameT", str_Date(2001, 4, 3), str_Date(2021, 1, 1), "Auth3", "BookD", 1946, "PH2", 1500);
	str_BookAccount A11(7, "family_nameY", str_Date(2005, 6, 15), str_Date(2021, 1, 1), "Auth5", "BookC", 2006, "PH1", 1500);

	p_bacc.add_account(std::move(A1));
	p_bacc.add_account(std::move(A2));
	p_bacc.add_account(std::move(A3));
	p_bacc.add_account(std::move(A4));
	p_bacc.add_account(std::move(A5));
	p_bacc.add_account(std::move(A6));
	p_bacc.add_account(std::move(A7));
	p_bacc.add_account(std::move(A8));
	p_bacc.add_account(std::move(A9));
	p_bacc.add_account(std::move(A10));
	p_bacc.add_account(std::move(A11));
}

int run()
{
	time_t t = time(nullptr);
	str_Date current_date = convert_ctime_to_str_Date(localtime_s(&t));
	str_BookAccount tech1, tech2;
	std::string base_name;
	std::string p_srch;

	std::cout << "Enter base name of your book accounter" << std::endl << "-> ";
	std::cin >> base_name;
	
	cl_BookAccounter D(base_name);

	if (D.is_empty())
	{
		init_gen(D);

		std::cout << "Generating initial bookaccounter";
		Sleep(500);
		std::cout << ".";
		Sleep(500);
		std::cout << ".";
		Sleep(500);
		std::cout << "." << std::endl << std::endl;
	}

	bool is_still_running = true;
	int option;

	while (is_still_running)
	{
		std::cout << std::endl << "1)Add account" << std::endl
			<< "2)Search by account" << std::endl
			<< "3)Search by library card" << std::endl
			<< "4)Search by author" << std::endl
			<< "5)Seach by publishing house" << std::endl
			<< "6)Peek last search result" << std::endl
			<< "7)Check outdated accounts" << std::endl
			<< "8)Delete account by account" << std::endl
			<< "9)Delete account by number" << std::endl
			<< "10)Change account by account" << std::endl
			<< "11)Load out to txt file" << std::endl
			<< "12)Exit" << std::endl << "->  ";

		std::cin >> option;

		std::cout << std::endl;

		switch (option)
		{
		case 1:
			std::cout << "Input account to add" << std::endl;
			std::cin >> tech1;
			D.add_account(std::move(tech1));
			break;
		case 2:
			std::cout << "Input account to search" << std::endl;
			std::cin >> tech1;
			D.search_account(tech1);
			break;
		case 3:
			std::cout << "Input library card number to search accounts" << std::endl;
			uint16_t p_lcn;
			std::cin >> p_lcn;
			D.search_account(p_lcn);
			break;
		case 4:
			std::cout << "Input author to search accounts" << std::endl;
			std::cin >> p_srch;
			D.search_account_auth(p_srch);
			break;
		case 5:
			std::cout << "Input publishing house to search accounts" << std::endl;
			std::cin >> p_srch;
			D.search_account_ph(p_srch);
			break;
		case 6:
			D.peek_last_result();
			break;
		case 7:
			D.check_outdated_accounts(current_date, true);
			break;
		case 8:
			std::cout << "Input account to delete" << std::endl;
			std::cin >> tech1;
			D.delete_account(tech1);
			break;
		case 9:
			std::cout << "Input number of account to delete" << std::endl;
			unsigned int p_num;
			std::cin >> p_num;
			D.delete_account(p_num);
			break;
		case 10:
			std::cout << "Input account to change" << std::endl;
			std::cin >> tech1;
			std::cout << "Input account to imply" << std::endl;
			std::cin >> tech2;
			D.change_account(tech1, std::move(tech2));
			break;
		case 11:
			D.load_out_txt(current_date);
			break;
		case 12:
			is_still_running = false;
			break;
		default:
			std::cout << "invalid option" << std::endl;
			break;
		}

	}
	return 1;
}

int main()
{
	return run();
}