#include <iostream>
#include <string>
#include <fstream>
#include <iterator>
#include <algorithm>
#include <vector>
#include <list>
#include <deque>
#include <functional>
#include <iomanip>
#include <math.h>

class GenerateFunctor
{

public:

	int operator ()()
	{
		return ((rand() % 101) - 50);
	}
};

class MultiplyFunctor
{
private:

	int cl_toMul;

public:

	MultiplyFunctor(int p_toMul) :
		cl_toMul(p_toMul)
	{}

	int operator ()(const int& p_toTr) const //!!! Фундаментальные типы НЕТ СМСЫСЛА ПЕРЕДАВАТЬ ПО ССЫЛКЕ
	{
		return p_toTr * cl_toMul;
	}


};

template<class Container, class Container_iterator> //!!! Зачем передавать Container_iterator?
void container_printout(const Container& p_cont)
{
	std::cout << "_____" << std::endl;
	unsigned int count = 1;
	

	std::for_each(p_cont.begin(), p_cont.end(), [&count](int p_elem) {
		std::cout << std::setw(4) << count << ")  " << std::setw(8) << p_elem << std::endl;
		count++;
		});

	
	std::cout << "_____" << std::endl << std::endl;
}


void createData_fstreams(const std::string& p_file_name)
{
	std::ofstream Fstr_out(p_file_name);

	for (int i = 0; i < 100; i++)
	{
		Fstr_out << ((rand() % 101) - 50) << "\n";
	}

	Fstr_out.close();
}


void createData_fstream_iterators(const std::string& p_file_name)
{
	std::ofstream Fstr_out(p_file_name);

	std::vector<int> vec_int; //!!! Все методы не должны зависеть от типа контейнера.
	vec_int.reserve(100);
	vec_int.resize(100);

	GenerateFunctor gen_fc;

	std::generate<std::vector<int>::iterator, GenerateFunctor>(vec_int.begin(), vec_int.end(), gen_fc);

	std::copy<std::vector<int>::iterator, std::ostream_iterator<int>>(vec_int.begin(), vec_int.end(), std::ostream_iterator<int>(Fstr_out, "\n"));

	vec_int.clear();
	vec_int.shrink_to_fit();

	Fstr_out.close();
}


template<class Container>
Container loadData_fstreams(const std::string& p_file_name)
{
	Container result_cont;
	std::ifstream Fstr_in(p_file_name);

	if (!Fstr_in.is_open())
	{
		throw std::exception("Wrong file name");
	}

	int just_read;

	while (Fstr_in >> just_read)
	{
		result_cont.push_back(just_read);
	}

	Fstr_in.close();

	return result_cont;
}


template<class Container>
Container loadData_fstream_iterators(const std::string& p_file_name)
{
	Container result_cont;
	std::ifstream Fstr_in(p_file_name);

	if (!Fstr_in.is_open())
	{
		throw std::exception("Wrong file name");
	}

	std::istream_iterator<int> fst(Fstr_in);
	std::istream_iterator<int> lst;

	result_cont.resize(100);

	std::copy(fst, lst, result_cont.begin());

	Fstr_in.close();

	return result_cont;
}


//      .

template<class Container>
bool Modify_regular(Container& p_container)
{
	if (p_container.size() == 0)
	{
		return true;
	}


    //!!! Несмотря на задание, функции не должны зависеть от конкретных типов
	int minimal = *std::min_element(p_container.begin(), p_container.end());
	int summ = 0;
	double abs_summ = 0;
	

	std::for_each(p_container.begin(), p_container.end(), [&summ, &abs_summ](int p_elem) {
		abs_summ += abs(p_elem);
		summ += p_elem;
		});

	

	auto container_iterator = p_container.begin();

	while (container_iterator != p_container.end())
	{
		*container_iterator *= minimal;
		container_iterator++;
	}

	p_container.push_back(summ);
	p_container.push_back(abs_summ / p_container.size());

	return true;
}

template<class Iterator>
bool Modify_iterators(Iterator p_iter_beg, Iterator p_iter_end)
{
	if (p_iter_beg == p_iter_end)
	{
		return true;
	}

	//!!! Несмотря на задание, функции не должны зависеть от конкретных типов
	int minimal = *std::min_element(p_iter_beg, p_iter_end);

	
	std::for_each(p_iter_beg, p_iter_end, [minimal](int& p_num)
		{
			p_num *= minimal;
		});
	
	return true;
}

template<class Container>
bool Modify_for_each(Container& p_container)
{
	if (p_container.size() == 0)
	{
		return true;
	}

    //!!! Несмотря на задание, функции не должны зависеть от конкретных типов
	int minimal = *std::min_element(p_container.begin(), p_container.end());

	auto p_cont_iter = p_container.begin();
	p_cont_iter++;

	std::for_each(p_container.begin(), p_container.end(), [minimal](int& p_num)
		{
			p_num *= minimal;
		});

	return true;
}

bool Modify_transform(const std::string& p_file_name)
{
	std::ifstream Fstr_in(p_file_name);

	if (!Fstr_in.is_open())
	{
		return false;
	}

	int minimal = 0;//!!! Несмотря на задание, функции не должны зависеть от конкретных типов
	int cur_num;//!!! Несмотря на задание, функции не должны зависеть от конкретных типов

	if (!Fstr_in >> minimal)
	{
		return true;
	}

	while (Fstr_in >> cur_num)
	{
		if (minimal > cur_num)
		{
			minimal = cur_num;
		}
	}

	MultiplyFunctor fnc(minimal);
	Fstr_in.close();
	Fstr_in.open(p_file_name);
	std::ofstream Fstr_out("res.txt");
	std::transform(std::istream_iterator<int>(Fstr_in), std::istream_iterator<int>(), std::ostream_iterator<int>(Fstr_out, "\n"), fnc);

	Fstr_in.close();
	Fstr_out.close();

	return true;
}

template<class Container>
bool outputResult_fstreams(const Container& p_container, const std::string& p_file_name)
{
	std::ofstream Fstr_out(p_file_name);
	if (!Fstr_out.is_open())
	{
		return false;
	}

	std::for_each(p_container.begin(), p_container.end(), [&Fstr_out](int p_num) {
		Fstr_out << p_num << "\n";
		});

	Fstr_out.close();
	return true;
}

template<class Container>
bool outputResult_copy(const Container& p_container, const std::string& p_file_name)
{
	std::ofstream Fstr_out(p_file_name);

	if (!Fstr_out.is_open())
	{
		return false;
	}

	std::copy(p_container.begin(), p_container.end(), std::ostream_iterator<int>(Fstr_out, "\n"));
	Fstr_out.close();
	return true;
}

bool Modify_in_place(const std::string& p_file_name)
{
	std::ifstream Fstr_in(p_file_name);

	if (!Fstr_in.is_open())
	{
		return false;
	}

	int minimal = 0;//!!! Несмотря на задание, функции не должны зависеть от конкретных типов
	int cur_num;//!!! Несмотря на задание, функции не должны зависеть от конкретных типов

	if (!Fstr_in >> minimal)
	{
		return true;
	}

	while (Fstr_in >> cur_num)
	{
		if (minimal > cur_num)
		{
			minimal = cur_num;
		}
	}

	Fstr_in.close();
	Fstr_in.open(p_file_name);

	MultiplyFunctor fnc(minimal);
	
	std::fstream Fstr(p_file_name, std::ios::in | std::ios::out); //!!! Зачем файл открывать на чтение и запись?
	
	if (!Fstr.is_open())
	{
		return false;
	}

	std::transform(std::istream_iterator<int>(Fstr_in), std::istream_iterator<int>(), std::ostream_iterator<int>(Fstr, "\n"), fnc);

	Fstr_in.close();
	Fstr.close();

	return true;
}